"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./taptic-engine.common"));
var taptic_engine_common_1 = require("./taptic-engine.common");
var TapticEngine = (function (_super) {
    __extends(TapticEngine, _super);
    function TapticEngine() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TapticEngine.prototype.notification = function (arg) {
        return new Promise(function (resolve, reject) {
            var generator = UINotificationFeedbackGenerator.new();
            if (generator === null) {
                reject("Unsupported Operating System");
                return;
            }
            var feedbackType = UINotificationFeedbackTypeSuccess;
            if (arg) {
                if (arg.type === taptic_engine_common_1.TapticEngineNotificationType.WARNING) {
                    feedbackType = UINotificationFeedbackTypeWarning;
                }
                else if (arg.type === taptic_engine_common_1.TapticEngineNotificationType.ERROR) {
                    feedbackType = UINotificationFeedbackTypeError;
                }
            }
            generator.notificationOccurred(feedbackType);
            resolve();
        });
    };
    TapticEngine.prototype.impact = function (arg) {
        return new Promise(function (resolve, reject) {
            var feedbackStyle = UIImpactFeedbackStyleMedium;
            if (arg) {
                if (arg.style === taptic_engine_common_1.TapticEngineImpactStyle.LIGHT) {
                    feedbackStyle = UIImpactFeedbackStyleLight;
                }
                else if (arg.style === taptic_engine_common_1.TapticEngineImpactStyle.HEAVY) {
                    feedbackStyle = UIImpactFeedbackStyleHeavy;
                }
            }
            var generator = UIImpactFeedbackGenerator.alloc().initWithStyle(feedbackStyle);
            if (generator === null) {
                reject("Unsupported Operating System");
                return;
            }
            generator.impactOccurred();
            resolve();
        });
    };
    TapticEngine.prototype.selection = function () {
        return new Promise(function (resolve, reject) {
            var generator = UISelectionFeedbackGenerator.new();
            if (generator === null) {
                reject("Unsupported Operating System");
                return;
            }
            generator.selectionChanged();
            resolve();
        });
    };
    return TapticEngine;
}(taptic_engine_common_1.Common));
exports.TapticEngine = TapticEngine;
var TapticEngineUnofficial = (function (_super) {
    __extends(TapticEngineUnofficial, _super);
    function TapticEngineUnofficial() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TapticEngineUnofficial.prototype.weakBoom = function () {
        return new Promise(function (resolve, reject) {
            AudioServicesPlaySystemSound(1519);
            resolve();
        });
    };
    TapticEngineUnofficial.prototype.strongBoom = function () {
        return new Promise(function (resolve, reject) {
            AudioServicesPlaySystemSound(1520);
            resolve();
        });
    };
    TapticEngineUnofficial.prototype.burst = function () {
        return new Promise(function (resolve, reject) {
            AudioServicesPlaySystemSound(1521);
            resolve();
        });
    };
    return TapticEngineUnofficial;
}(taptic_engine_common_1.Common));
exports.TapticEngineUnofficial = TapticEngineUnofficial;
